#include <mega8.h>
#include <delay.h>
#include <spi.h>

#define BLANK     PORTD.1
#define DCPRG     PORTD.6 
#define GSCLK     PORTD.4
#define SIN       PORTB.3
#define SCLK      PORTB.5 
#define XLAT      PORTB.1 

#define led_on    PORTB.0=1
#define led_off   PORTB.0=0

unsigned int i, timer_4096=0, new_data=0; 


// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
GSCLK=1;
GSCLK=0;
timer_4096++;
if (timer_4096>=4096)
 {
 timer_4096=0;
 BLANK=1; 
 if (new_data==1)
   {
   XLAT=1;
   XLAT=0;
   new_data=0;
   };
 };
TCCR0=0x05;
}


void write_data_spi (unsigned char data_spi)
{
BLANK=1;
for (i=1; i<=24; i++) spi(data_spi); 
BLANK=0;
new_data=1;
}


void main(void)
{
DDRB=0x2F;
DDRD=0x52;
SPCR=0x51;            // SPI Clock Rate: 1000,000 kHz
SPSR=0x00;            // SPI Data Order: MSB First
TCCR0=0x00;           // Timer/Counter 0 initialization 
TCNT0=0x00;
TIMSK=0x01;    // Timer(s)/Counter(s) Interrupt(s) initialization
#asm("sei")

GSCLK=0;
XLAT=0;
DCPRG=0;
BLANK=1;
 
write_data_spi(0x00);
TCCR0=0x05;

while (1)
  { 
  led_on;
  delay_ms(100);
  led_off;
  delay_ms(100); 
  };      
}
